# This is really a noarch package, we're just building on all arches so we 
# can run unit tests across all arches.   The debuginfo will always be empty
# (no executables or libraries,) so we can disable it
%global debug_package %{nil}

Name:           metslib
Version:        0.5.3
Release:        4%{?dist}
Summary:        Metaheuristic modeling framework and optimization toolkit in modern C++

License:        GPLv3+ or CPL
URL:            https://projects.coin-or.org/metslib
Source0:        http://www.coin-or.org/download/source/%{name}/%{name}-%{version}.tgz
# Removes all "libdir" paths from .pc file (which are unneeded).  Not upstream
Patch0:         %{name}-0.5.3-noarch.patch

BuildRequires:  doxygen
BuildRequires:  graphviz

%description
%{summary}.

%package        devel
Summary:        Metaheuristic modeling framework and optimization toolkit in modern C++
Provides:       %{name}-static = %{version}-%{release}
BuildArch:      noarch

%description    devel
METSlib is a metaheuristic modeling framework and optimization toolkit in
modern C++ released as Free/Libre/Open Source Software.

Model and algorithms are modular: any search algorithm can be applied to the
same model. On the other hand no assumption is made on the model, you can
work on any problem type: timetabling, assignment problems, vehicle routing,
bin-packing and so on.

Once you have implemented your model in the problem framework, the library
makes easy testing different Tabu Search strategies or even different
algorithms (Simulated Annealing or other local search based algorithms) with
a few lines of code.

%package doc
Summary:     Documentation for %{name}
BuildArch:   noarch

%description doc
The %{name}-doc package provides documentation for the %{name} library.

%prep
%setup -q
%patch0 -p0
# Disable -O3 optimization for unit tests
sed -i 's| -O3||g' configure

%build
%configure 
CXXFLAGS="%{optflags}" make %{?_smp_mflags}
doxygen doxydoc/doxygen.conf

%install
%make_install
# Move pkgconfig file to /usr/share/pkgconfig (since package is noarch)
mkdir -p %{buildroot}%{_datadir}
mv %{buildroot}%{_libdir}/pkgconfig %{buildroot}%{_datadir}

%check
make test

%files devel
%doc AUTHORS COPYING NEWS README 
%{_includedir}/*
%{_datadir}/pkgconfig/*.pc

%files doc
%doc doxydoc/html COPYING

%changelog
* Fri Aug 23 2013 Rich Mattes <richmattes@gmail.com> - 0.5.3-4
- Added -doc subpackage
- Fixed license to read GPLv3+ instead of GPLv3

* Thu Aug 22 2013 Rich Mattes <richmattes@gmail.com> - 0.5.3-3
- Remove -O3 from configure instead of configure.ac

* Sun Aug 11 2013 Rich Mattes <richmattes@gmail.com> - 0.5.3-2
- Removed metslib virtual provide
- Removed optimization flags from unit tests
- Added patch to remove libdir references from pkgconfig file

* Sun Aug 04 2013 Rich Mattes <richmattes@gmail.com> - 0.5.3-1
- Initial package
